=== binr/ravc2/Makefile ===
BIN=ravc2
BINDEPS=r_core r_main

include ../rules.mk
include ../../libr/main/deps.mk
include ../../shlr/zip/deps.mk
include ../../shlr/java/deps.mk
include ../../shlr/gdb/deps.mk

LDFLAGS+=$(LINK)
