=== libr/search/Makefile ===
include ../config.mk

NAME=r_search
OBJS=search.o bytepat.o strings.o aes-find.o privkey-find.o
OBJS+=regexp.o keyword.o uds.o
# OBJ+=rsakey.o
R2DEPS=r_util
CFLAGS+=-g

include ../rules.mk
